


// Select all to run ([Apple] + [A]), then press Enter.

// 								Critical evaluation
//
// 	When I first set out on this task I decided that I would like to attempt to create something
//	 which would, in a sense, be usable. That is to say I wanted to make something that could
// 	algorithmically generate a cohesive rhythm (i.e. that didn't sound like a continuous stream of
// 	random drum hits - with little or no definition of beats, and more importantly, bars). In this respect,
//	In my opinion, it's all well and good hiding behind the guise of I.D.M. - saying "its meant to sound
//	disjointed like that" - but I feel, in the context of algorithmical composition, you need to have a stable and
//	maliable code base from which to branch out from in terms of complexity.
//
// 	I feel that although I have in succeeded in my aims to some degree, I could have
// 	implimented them far more elegantly. Given the time to start from scratch there are many things
// 	I would have liked to have done differently. For example, I would have liked to have explored the
// 	algorithmic relationships between the different drum sounds and their relative timings in making
// 	a coherent rhythmic drum beat, as opposed to the coded "drum loops" I used, which were more or less
//	independant of each other.

//	Replace the paths below with correct ones for your machine.


var w;
var tempoBox, mainBut, mainButState, kickBut, kickButState, snareBut, snareButState, hatBut, hatButState, rideBut, rideButState, resBut, resButState, montBut, montButState, padBut, padButState, synBut, synButState;
var stream,streamk,streamkv,streams,streamsv,streamh,streamhv,streamr,streamrv,streamp,streampv,streamm,streammv,streamblpf, streamsynv, snarechange, ridechange, kickchange, da, synvol2 = 0.9, hatpanstream, hp1 = 0, hp2 = 0;
var snrrush, snrrushstream, snrchoice;
var kickPat = 8, snarePat, kickOn = 0, snareOn = 0.9, hatOn = 0, rideOn = 0, beatlpf = 16000, montOn = 0, padOn = 0, synOn = 0;
var myTempo = 1, bt = 0.5;
var frq = 37, melPat, melTime = 0.25;
var snrVol = 0;
var res = 200, resMul, resMan = 1;
var padx, cs;
var totalRelativeTime = 2.0;



Speech.init(2);

w = Window("Algo plus Micro", Rect(20, 800, 540, 500));

// ~path = "/Users/rich/Documents/music/devs/algorithms/0514183_algo_and_micro/";

~path = PathName(thisProcess.nowExecutingPath).pathOnly;
~path.postln;



c = Buffer.read(s, ~path ++ "hat.aiff", 0, -1, 0 , 0);
d = Buffer.read(s, ~path ++ "kick1.aiff", 0, -1, 0 , 1);
e = Buffer.read(s, ~path ++ "snare1.aiff", 0, -1, 0 , 2);
f = Buffer.read(s, ~path ++ "ride1.aiff", 0, -1, 0 , 3);
g = Buffer.read(s, ~path ++ "snare2.aiff", 0, -1, 0, 16);
h = Buffer.read(s, ~path ++ "snare3.aiff", 0, -1, 0, 17);
v = Buffer.read(s, ~path ++ "ride2.aiff", 0, -1, 0, 18);
da = Buffer.read(s, ~path ++ "kick2.aiff", 0, -1, 0, 19);



i = Buffer.read(s,~path ++ "vox001.aif", 0, -1, 0 , 4);
j = Buffer.read(s,~path ++ "vox002.aif", 0, -1, 0 , 5);
k = Buffer.read(s,~path ++ "vox003.aif", 0, -1, 0 , 6);
l = Buffer.read(s,~path ++ "vox004.aif", 0, -1, 0 , 7);
m = Buffer.read(s,~path ++ "vox005.aif", 0, -1, 0 , 8);
n = Buffer.read(s,~path ++ "vox006.aif", 0, -1, 0 , 9);
o = Buffer.read(s,~path ++ "vox007.aif", 0, -1, 0 , 10);
p = Buffer.read(s,~path ++ "vox008.aif", 0, -1, 0 , 11);
q = Buffer.read(s,~path ++ "vox009.aif", 0, -1, 0 , 12);
r = Buffer.read(s,~path ++ "vox010.aif", 0, -1, 0 , 13);
t = Buffer.read(s,~path ++ "vox011.aif", 0, -1, 0 , 14);
u = Buffer.read(s,~path ++ "vox012.aif", 0, -1, 0 , 15);




///////////////////////////////////////
////         SYNTHDEFS             ////
///////////////////////////////////////




SynthDef("microMontage", { arg dur = 10, bufnum=4, myStartPos=100, montVol, ratevar; // Micromontage synthdef
	var out=0, rate;
	dur = 10;
	rate = LFNoise0.kr(0.0025, LFNoise1.kr(0.001, ratevar));
	Out.ar(0, ([EnvGen.kr(Env.perc(dur/3, dur/3, 1, -4), 1.0, doneAction: 2),EnvGen.kr(Env.perc(dur/2, dur/2, 1, -4), 1.0, doneAction: 2)])
		* (FreeVerb.ar(Pan2.ar(PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum) * rate, startPos: myStartPos, loop: 1.0),FSinOsc.kr(LFNoise0.kr(0.25, 0,LFNoise0.kr(0.2, 10)))), 0.6, 0.6, 0.9)) * montVol * MouseY.kr(0.2,0,0);
	);
}).send(s);




s = Server.local;


SynthDef("snare",{ arg i_out = 0,snareVol,snareVol2,snareVol3,beatfilt, bufnum=2, rate = 1; // Snare drum synthdef


	var out;
	out =RLPF.ar(
		HPF.ar(
		PlayBuf.ar(1,bufnum, BufRateScale.kr(0) * rate, loop:0) * EnvGen.kr(Env.linen(0.01, 0.8, 0.1), 1, 0.5, doneAction:2) * [snareVol,snareVol] * [snareVol2,snareVol3],
		500),
		beatfilt, 0.9);
		Out.ar(i_out, out);
}).send(s);


SynthDef("kick",{ arg i_out = 0,kickVol,beatfilt, bufnum = 1;  // Kick drum synthdef
	var out;
	out =RLPF.ar(
		PlayBuf.ar(1,bufnum, BufRateScale.kr(0), loop:0) * EnvGen.kr(Env.linen(0.01, 0.2, 0.1), 1, 0.5, doneAction:2) * [kickVol,kickVol],
		beatfilt,
		0.9);
		Out.ar(i_out, out);
}).send(s);


SynthDef("hat",{ arg i_out = 0,hatVol,beatfilt,hatenv, hatpan1, hatpan2;  // Hihat synthdef
	var out;
	out =RLPF.ar(
		PlayBuf.ar(1,0, BufRateScale.kr(0), loop:0) * EnvGen.kr(Env.linen(0.01,
		hatenv,
		0.01), 1, 0.5, doneAction:2) * [hatVol,hatVol] * [hatpan1,hatpan2] * 0.5,
		beatfilt, 0.9);
		Out.ar(i_out, out);
}).send(s);


SynthDef("ride",{ arg i_out = 0,rideVol,beatfilt, bufnum = 3;  // Ride cymbal synthdef
	var out;
	out =RLPF.ar(
		HPF.ar(PlayBuf.ar(1,bufnum, BufRateScale.kr(0), loop:0) * EnvGen.kr(Env.linen(0.01, 1.8, 0.1), 1, 0.5, doneAction:2) * [rideVol,rideVol] * 0.5, 4000),
		beatfilt, 0.9);
		Out.ar(i_out, out);
}).send(s);






//////////////////////// Main Synth synthdef





SynthDef( "Algosynth", { arg i_out=0, freq, reson = 4000, synVol = 0, synVol2;
	var out;
	out = RLPF.ar(
		RLPF.ar(
		Saw.ar([freq,freq+0.2], mul: EnvGen.kr( Env.perc, levelScale: 0.15, doneAction: 2 ) * [synVol] * 0.6 * synVol2),


		LFNoise1.kr(1, 36, 110).midicps,
		0.2),
		reson,1);
	4.do({ out = AllpassN.ar(out, 0.125, [0.125.rand, 0.125.rand], 4) });
	Out.ar( i_out, out );
}).send(s);



//////////////////////// Pad Synth synthdef



SynthDef( "Algopad", { arg i_out=0, freq, padVol = 0, padvol2 = 0, padvol3 = 0;
	var out;
	out = HPF.ar(Klang.ar([`[[freq.midicps,(freq-0.2).midicps],[0.2, 0.6]],`[[(freq-0.1).midicps,(freq+0.2).midicps],[0.2, 0.6]]], 1, 0) * EnvGen.kr( Env.new([0,1,0],[0.1,1.8]), levelScale: 0.15, doneAction: 2 ),1000) * [padVol,padVol] * [padvol2,padvol3];
	Out.ar( i_out, out );
}).send(s);




///////////////////////////////////////
////         ROUTINES              ////
///////////////////////////////////////


kickchange = Task({ arg myBuf;
	loop{
		1.do {



			s.sendMsg("/s_new", "kick", s.nextNodeID, 1, 0, "bufnum", myBuf.bufnum);
		};


	};
});

snarechange = Task({ arg myBuf;
	loop{
		1.do {



			s.sendMsg("/s_new", "snare", s.nextNodeID, 1, 0, "bufnum", myBuf.bufnum);
		};


	};
});

ridechange = Task({ arg myBuf;
	loop{
		1.do {



			s.sendMsg("/s_new", "ride", s.nextNodeID, 1, 0, "bufnum", myBuf.bufnum);
		};


	};
});




streamm = Task({ arg myBuf, myWait; //micromontage "stream"
	loop {
		3.do {
			s.sendMsg("/s_new", "microMontage", s.nextNodeID, 1, 0, "dur", myWait, "bufnum", myBuf.bufnum, "myStartPos", rand(myBuf.numFrames); );
		};
	};
});




streamblpf = Routine.new({ //Beat low pass filter stream
	loop({
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		[200,500,1000,2000,3000,5000,7000,16000].choose.yield;
		if (0.5.coin,{
			200.yield;
			300.yield;
			500.yield;
			800.yield;
			1000.yield;
			2000.yield;
			4000.yield;
			2000.yield;
			1000.yield;
			500.yield;
			200.yield;
		});
		if (0.5.coin,{
			16000.yield;
			16000.yield;
			16000.yield;
			16000.yield;
			16000.yield;
			16000.yield;
			16000.yield;
			16000.yield;
			16000.yield;
			16000.yield;
		});
	});
});

stream = Routine.new({ // Main synth frequency stream
	loop({
	melPat = [1,2].choose;
	if (melPat == 1,{
		melTime = 0.25;
		frq.yield;
		(frq+12).yield;
		(frq+24).yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		(frq+24).yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		(frq+24).yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		(frq+24).yield;
		(frq+12).yield;
		frq = #[37,39,42,44,46].choose;
	},{
		melTime = 0.25;
		frq.yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		frq.yield;
		(frq+12).yield;
		frq = #[37,39,42,44,46].choose;
		});
	});
});

streamp = Routine.new({ // Pad synth frequency stream
	loop({
	padx = [24,27,29,31].choose;
	(frq+padx).yield;
	});
});

streampv = Routine.new({ // Pad synth volume stream
	loop({
	if (padOn == 0,{
		0.yield;
	},{
		1.yield;
	});
	});
});

streamsynv = Routine.new({ // Main synth volume stream
	loop({
	if (synOn == 0,{
		0.yield;
	},{
		0.6.yield;
	});
	});
});

streamk = Routine.new({ // Kick drum sequences
	loop({
		if (kickPat == 1,{
			0.5.yield;
			0.25.yield;
			0.5.yield;
			0.5.yield;
			0.25.yield;
		});
		if (kickPat == 2,{
			0.75.yield;
			0.125.yield;
			0.25.yield;
			0.25.yield;
			0.625.yield;
		});
		if (kickPat == 3,{
			1.25.yield;
			0.5.yield;
			0.25.yield;
		});
		if (kickPat == 4,{
			0.25.yield;
			0.75.yield;
			0.375.yield;
			0.625.yield;
		});
		if (kickPat == 5,{
			0.125.yield;
			0.125.yield;
			0.125.yield;
			0.25.yield;
			0.0625.yield;
			0.0625.yield;
			0.125.yield;
			0.125.yield;
			0.25.yield;
			0.125.yield;
			0.125.yield;
			0.125.yield;
			0.25.yield;
			0.125.yield;
		});
		if (kickPat == 6,{
			0.125.yield;
			1.875.yield;
		});
		if (kickPat == 7,{
			[2,4,8].choose.yield;
		});
		if (kickPat == 8,{
			0.5.yield;
			0.5.yield;
			0.5.yield;
			0.5.yield;
		});
	kickPat = [1,2,3,4,5,6,7,8].choose;
	});
});

streamkv = Routine.new({ // Kick drum volume control
	loop({
	if (kickOn == 0,{
		0.yield;
	},{
		1.yield;
	});
	});
});

streamh = Routine.new({ // Hihat sequencing
	loop({
	0.25.yield;
	0.25.yield;
	0.25.yield;
	[1,0.75,0.5].choose.yield;
		rrand(1,5).do({
			0.125.yield;
			0.25.yield;
			0.5.yield;
		});
	if (0.5.coin,{
		0.125.yield;
		0.125.yield;
		0.125.yield;
		0.125.yield;
		0.125.yield;
		0.125.yield;
		0.125.yield;
		0.125.yield;
	});
	if (0.03.coin,{
		[1,2,3,4].choose.yield;
	});
	});
});

streamhv = Routine.new({ //Hihat volume control
	loop({
	if (hatOn == 1,{
		[1, 0.8, 0.6, 0.5, 0.3, 0.1, 0].choose.yield;
	},{
		0.yield;
	});
	});
});

streams = Routine.new({ // Snare drum sequencing
	loop({
	snarePat = [1,2,3].choose;
	if (snarePat == 1,{
		snrVol = (0.9 - snareOn).ceil.abs;
		0.5.yield;
		snrVol = (0 - snareOn).ceil.abs;
		0.5.yield;
		snrVol = (0.9 - snareOn).ceil.abs;
		0.5.yield;
		snrVol = (0 - snareOn).ceil.abs;
		0.5.yield;
	});
	if (snarePat == 2,{
		snrVol = (0.9 - snareOn).ceil.abs;
		0.5.yield;
		0.375.yield;
		0.375.yield;
		0.375.yield;
		snrVol = (0 - snareOn).ceil.abs;
		0.375.yield;
	});
	if (snarePat == 3,{
		snrVol = (0.9 - snareOn).ceil.abs;
		0.5.yield;
		snrVol = (0 - snareOn).ceil.abs;
		0.25.yield;
		snrVol = (0.9 - snareOn).ceil.abs;
		0.5.yield;
		snrVol = (0 - snareOn).ceil.abs;
		0.75.yield;
	});
	if (0.03.coin,{
		snrrush = 1;
		snrVol = 0.05;
		0.0078125.yield;
		0.0078125.yield;
		0.0078125.yield;
		0.0078125.yield;
		snrVol = 0.1;
		0.015625.yield;
		0.015625.yield;
		0.015625.yield;
		0.015625.yield;
		0.015625.yield;
		0.015625.yield;
		snrVol = 0.2;
		0.03125.yield;
		0.03125.yield;
		0.03125.yield;
		0.03125.yield;
		snrVol = 0.4;
		0.0625.yield;
		0.0625.yield;
		0.0625.yield;
		0.0625.yield;
		snrVol = 0.6;
		0.125.yield;
		0.125.yield;
		0.125.yield;
		0.125.yield;
		snrVol = 0.25;
		0.25.yield;
		0.25.yield;
		0.125.yield;
		snrVol = 0.5;
		0.125.yield;
		snrVol = 0.8;
		0.125.yield;
		snrVol = 0.99;
		0.125.yield;
		snrrush = 0;
	});
	if (0.02.coin,{
		[2,4,8].choose.yield;
	});
	});
});

snrrushstream = Routine.new({ // limits the samples to choose from during the "snare rush"
	loop({
		if(snrrush == 1,{
			snrchoice = [e,h].choose;
		},{
			snrchoice = [e,g,h].choose;
		});
		0.yield;
	});
});

streammv = Routine.new({ //micromontage volume control
	loop({
		if (montOn == 0,{
				0.yield;
			},{
				1.yield;
			});
		});
});

streamr = Routine.new({ //Ride cymbal sequencing
	loop({
		[1,2,4,8].choose.yield;
		});
});
streamrv = Routine.new({ // Ride cymbal volume control
	loop({
	if (rideOn == 0,{
		0.yield;
	},{
		1.yield;
	});
	});
});

hatpanstream = Routine.new({ // controls the hihats panning (i couldn't get Pan2.ar to work as i wanted)
	loop({
		hp1 = (0.5.rand) + 0.2;
		hp2 = 1 - hp1;
		0.yield;
	});
});





///////////////////////////////////////
////          G.U.I.              /////
///////////////////////////////////////

a = StaticText(w, Rect(0, 30, 540, 480))
	.string_("Barrie Manning")
	.stringColor_(Color.new(1,1,1,0.15))
	.font_(Font("Helvetica-Bold", 120))
;

a = StaticText(w, Rect(-80, -1298, 2000, 2000))
	.string_(".")
	.stringColor_(Color.new(1,1,1,0.3))
	.font_(Font("Helvetica-Bold", 1400))
;

a = StaticText(w, Rect(220, -50,310, 280));
a.font_(Font("Helvetica", 10));
a.string = "This version of the patch is fully automated/algorithmic.

- This patch contains both my algorithmic and micromontage submissions.

- The [Start] button is a general on/off switch for the whole patch.

- The volume of the micromontage sound is controlled by the mouse Y axis.";
a.stringColor_(Color.new(0,0,0,0.85));

a = StaticText(w, Rect(20, 165,510, 300));
a.font_(Font("Helvetica", 10));
a.string = "- Both synth sounds are controlled by the same algorithm, although the pad sound's values are modified by a further simple calculation

- The drums are controlled by randomly chosen streams - which each conform to a basic 4/4 time signature. The hihats however are an exception in that they are less reliant on the time signature. I decided to do it this way because earlier attempts of mine to create algorithmic beats resulted in what sounded like a continuous stream of random hits.

- The hihat's envelope and pan are chosen on each occurence.

- The cymbal, snare and kick drum's source sounds are changed via .choose on a note to note basis.

- All the drums have a LP filter which are controlled from an individual stream.

- The pad synth's timing is chosen on a note by note basis.

- The micromontage source sounds are chosen on the fly, the rate of change is mostly controlled by LFNoise UGENS but are influenced by a .choose.";
a.stringColor_(Color.new(0,0,0,0.85));

mainBut = Button(w, Rect(20,28,180,180)) // Starts and stops everything



		.states_([["Play", Color.black, Color.green],["Stop", Color.black, Color.red]])


		.action_({mainButState = mainBut.value;

					fork {


						while ( { mainButState == 1 }, // Main algorithmic sequencing



							{
									1.do({
									montOn = 1;
					(16/totalRelativeTime).wait;
									rideOn = 1;
									(4/totalRelativeTime).wait;
									hatOn = 1;
									(4/totalRelativeTime).wait;
									kickOn = 1;
									(4/totalRelativeTime).wait;
									snareOn = 0;
									(20/totalRelativeTime).wait;
									frq = 36;
									synOn = 1;
									hatOn = 0;
									(16/totalRelativeTime).wait;
									montOn = 0;
									hatOn = 1;
									padOn = 1;
									(30/totalRelativeTime).wait;
									res = 1000;
									(0.5/totalRelativeTime).wait;
									res = 2000;
									synvol2 = 0.9;
									(0.5/totalRelativeTime).wait;
									res = 3000;
									synvol2 = 0.8;
									(0.5/totalRelativeTime).wait;
									res = 4500;
									synvol2 = 0.7;
									(0.5/totalRelativeTime).wait;
									padOn = 0;
									res = 6000;
									synvol2 = 0.6;
									(16/totalRelativeTime).wait;
									res = 5000;
									synvol2 = 0.7;
									(2/totalRelativeTime).wait;
									res = 4000;
									synvol2 = 0.8;
									(2/totalRelativeTime).wait;
									res = 3000;
									synvol2 = 0.9;
									(2/totalRelativeTime).wait;
									res = 2000;
									synvol2 = 1;
									(2/totalRelativeTime).wait;
									padOn = 1;
									res = 1000;
									(2/totalRelativeTime).wait;
									res = 800;
									(2/totalRelativeTime).wait;
									res = 600;
									(2/totalRelativeTime).wait;
									res = 400;
									(2/totalRelativeTime).wait;
									res = 200;
									hatOn = 0;
									montOn = 1;
									(16/totalRelativeTime).wait;
									rideOn = 0;
									snareOn = 0.9;
									kickOn = 0;
									synOn = 0;
									(32/totalRelativeTime).wait;
									padOn = 0;
									montOn = 0;
									(4/totalRelativeTime).wait;
									Speech.channels[0].volume_(-20.dbamp);
									Speech.channels[0].pitch_(60.rand+20);


									Speech.channels[0].speak("thee");
									0.5.wait;
									Speech.channels[0].pitch_(40.rand+20);
									Speech.channels[0].speak("end");



									(11.5/totalRelativeTime).wait;


									})
						} )


					};



					fork {



						while ( { mainButState == 1 },
							{
									1.do({
									Synth("kick",[\kickVol, streamkv.next, \beatfilt, streamblpf.next, \bufnum, [d,da].choose]);
									streamk.next.wait;


									})
						} )


					};
				fork {



						while ( { mainButState == 1 },
							{
									1.do({
									hatpanstream.next.wait;


									Synth("hat",[\hatVol, streamhv.next, \beatfilt, streamblpf.next, \hatenv, [0.03, 0.06, 0.1, 0.4, 1].choose, \hatpan1, hp1, \hatpan2, hp2]);



									streamh.next.wait;


									})
						} )


					};
				fork {
						while ( { mainButState == 1 },



							{
									1.do({
									snrrushstream.next.wait;


									Synth("snare", [\snareVol, snrVol, \beatfilt, streamblpf.next, \bufnum, snrchoice, \snareVol2, 0.2, \snareVol3, 1, \rate, 0.95]);
									Synth("snare", [\snareVol, snrVol, \beatfilt, streamblpf.next, \bufnum, snrchoice, \snareVol2, 1, \snareVol3, 0.2, \rate, 1.05]);
									streams.next.wait;
									})
						} )


					};
				fork {
						while ( { mainButState == 1 },



							{
									1.do({


									Synth("ride", [\rideVol, streamrv.next, \beatfilt, streamblpf.next, \bufnum, [f,v].choose]);



									streamr.next.wait;


									})
						} )


					};
				fork {
						while ( { mainButState == 1 },



							{
									1.do({
									Synth( "Algosynth", [ \freq, stream.next.midicps, \reson, res, \synVol, streamsynv, \synVol2, synvol2] );
									melTime.wait;


									})
						} )


					};
				fork {
						while ( { mainButState == 1 },



							{
									1.do({
									0.5.wait;
									Synth( "Algopad", [ \freq, streamp.next, \padVol, streampv.next, \padvol2, 1, \padvol3, 0.3]);
									[0.5, 1].choose.wait;
									Synth( "Algopad", [ \freq, streamp.next, \padVol, streampv.next, \padvol2, 0.3, \padvol3, 1]);
									[0.5, 1].choose.wait;


									})
						} )


					};
				fork {
						while ( { mainButState == 1 },



							{
									3.do({
									Synth( "microMontage", [ \montVol, streammv.next, \bufnum, [i,j,k,l,m,n,o,p,q,r,t,u].choose, \ratevar, [1,10,20,50,100,200,500,750].choose]);
									[0.001, 0.01, 0.1, 0.5, 0.75, 1, 1.5, 2, 4].choose.wait;


									})
						} )


					};
				fork {
						while ( { mainButState == 0 },



							{
									1.do({
									frq = 36;
									kickOn = 0;
									hatOn = 0;
									rideOn = 0;
									snareOn = 0.9;
									montOn = 0;
									padOn = 0;
									synOn = 0;
									stream.reset;
									streamk.reset;
									streamkv.reset;
									streamh.reset;
									streamhv.reset;
									streams.reset;
									streamsynv.reset;
									streamr.reset;
									streamrv.reset;
									streamp.reset;
									streampv.reset;
									streammv.reset;
									0.1.wait;
									})


						} )


					};

		});


w.front;