(

// algo001 v0.04 131102
// Really basic - SinOsc and one tone
// Uses case and collections of arpeggiated triads
// Uses SCNumberBox
// Prohibits values lower than 0.01;

var w;
var mainBut, mainButState;
var myTime = 0.1, timeBox, randTime;
var stream;

w = Window("SC Algorithm GUI Tutor 001", Rect(20, 800, 240, 100));



// Synth to play it: in this case it's a basic sine wave.  You can experiment with others...
s = Server.local;


SynthDef( "Algorithmic", { arg i_out=0, freq;
	var out;

	out = SinOsc.ar( freq, 0, mul: EnvGen.kr( Env.perc(0.001, 0.2, 1.0, -4), levelScale: 0.1, doneAction: 2 ));

	Out.ar( i_out, out );
}).send(s);



// here's the stream...

stream = Routine.new({
	loop({
 // Using case here: the choice of numbers, etc, is arbitrary...
	z = [0, 1, 2, 3, 4, 5];
	i = z.choose;
	x = case
		{ i == 0 }	{ 60.yield; 63.yield; 67.yield; } // c minor
		{ i == 1 }	{ 60.yield; 64.yield; 67.yield; } // c major
		{ i == 2 }	{ 59.yield; 62.yield; 67.yield; } // g major
		{ i == 3 }	{ 58.yield; 62.yield; 67.yield; } // g minor
		{ i == 4 }	{ 57.yield; 60.yield; 65.yield; } // f major
		{ i == 5 }	{ 56.yield; 60.yield; 65.yield; }; // f minor
	i.postln;

 	});
});

// look at the other examples, but also:
// choose, if, while, for, forBy, do, switch, case
// see control structures, and think up some uses for them



// The static text for the word 'speed'
a = StaticText(w, Rect(130, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "speed";



timeBox = NumberBox(w, Rect(130, 40, 60, 20));
		timeBox.clipLo = 0.01;
		timeBox.value = 0.1;
		timeBox.scroll_step = 0.01;
		timeBox.action = ({ arg v;
			myTime = v.value;
		});

// The static text for the word 'seconds'


a = StaticText(w, Rect(200, 40, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "secs";




mainBut = Button(w, Rect(20,40,100,20))

		.states_([["Play"],["Stop"]])
		.action_({ arg butt;
			mainButState = mainBut.value;

					fork {
						while ( { mainButState == 1 }, // this is if the button is on!
							{
									1.do({
									// The synth is described above...
									Synth( "Algorithmic", [ \freq, stream.next.midicps ] );
									// This transposes the stream up an octave:
									// Synth( "Algorithmic", [ \freq, (stream.next)+12.midicps ] );
									// myTime is initialised above at 0.1...
									myTime.wait; // synonym for yield, used by .play to schedule next occurence
									})


						} ) // end while
					}; // end fork

		}); // end of action
w.front;
)
