(
// algo003 004 131102 Example from streams.
// 091019: shortened sounds,
// included perc envelope details - remove details to revert,
// brought down overall level

var w;
var mainBut, mainButState;
var myTime = 0.1, timeBox, randTime;
var stream, dur;

w = Window("SC Algorithm GUI Tutor 003", Rect(20, 800, 240, 100));


// Synth to play it (from Streams...)
s = Server.local;


SynthDef( "Help-SPE1", { arg i_out=0, freq;
	var out;
	out = RLPF.ar(
		LFSaw.ar( freq, mul: EnvGen.kr( Env.perc(0.001, 0.2, 1, -4), levelScale: 0.05, doneAction: 2 )),
		LFNoise1.kr(1, 36, 110).midicps,
		0.1
	);
	4.do({ out = AllpassN.ar(out, 0.05, [0.05.rand, 0.05.rand], 4) });
	Out.ar( i_out, out );
}).send(s);



// here's the stream...

dur = 1/8;
stream = Routine.new({
	inf.do({ // or loop
		if (0.5.coin, {
			// run of fifths:
			24.yield;
			31.yield;
			36.yield;
			43.yield;
			48.yield;
			55.yield;
		});
		rrand(2,5).do({
			// varying arpeggio
			60.yield;
			#[63,65].choose.yield;
			67.yield;
			#[70,72,74].choose.yield;
		});
		// random high melody
		rrand(3,9).do({  #[74,75,77,79,81].choose.yield });
	});
});



// The static text for the word 'speed'


a = StaticText(w, Rect(130, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "speed";



// Code for the number box
timeBox = NumberBox(w, Rect(130, 40, 60, 20));
		timeBox.clipLo = 0.01;
		timeBox.scroll_step = 0.01;
		timeBox.value = 0.1;
		timeBox.action = ({ arg tb;
			myTime = tb.value;
		});


// The static text for the word 'seconds'


a = StaticText(w, Rect(190, 40, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "secs";




mainBut = Button(w, Rect(20,40,100,20))


		.states_([["Play"],["Stop"]])
		.action_({ arg butt;
			butt.value.postln;
			mainButState = mainBut.value;




					fork {
						while ( { mainButState == 1 }, // this is if the button is on!
							{
									1.do({
									// The synth is described above...


									Synth( "Help-SPE1", [ \freq, stream.next.midicps ] );
									// myTime is initialised above at 0.1...
									myTime.wait; // synonym for yield, used by .play to schedule next occurence
									})


						} ) // end while
					}; // end fork






		}); // end of action
w.front;
)
