(
// algo007 v002 131102
// Includes a badly functioning transposed number box.
// Necessitates a reset button
// the two boxes below play are allPass and noise frequency,
// the two boxes below those are number of values and transposition

var w;
var mainBut, mainButState;
var resetBut, resetBut2;
var myTime = 0.1, timeBox, randTime;
var noiseFreq=1, noiseFreqNB;
var allPassBox, allPassVal = 0.1;
var pPatArray, pPatNB, pPatNum = 6;
var pPatNumNB;
var pPatTransNB, pPatTrans = 0;
var stream;

w = Window("SC Algorithm GUI Tutor 007", Rect(20, 700, 500, 250));




timeBox = NumberBox(w, Rect(130, 20, 60, 20));
		timeBox.clipLo = 0.02;
		timeBox.scroll_step = 0.01;
		timeBox.value = 0.1;
		timeBox.action = ({ arg tb;
			myTime = tb.value;
		});

allPassBox = NumberBox(w, Rect(20, 50, 40, 20));
		allPassBox.clipLo = 0.01;
		allPassBox.scroll_step = 0.01;
		allPassBox.value = 0.1;
		allPassBox.action = ({ arg tb;
			allPassVal = tb.value;
		});

noiseFreqNB = NumberBox(w, Rect(60, 50, 40, 20))
		.value_(1)
		.scroll_step_(1)
		.clipLo_(0)
		.clipHi_(200)
		.background_(Color.blue(0.0,0.1))
		.action_({ arg v;
			noiseFreq = v.value;
		});

pPatNumNB = NumberBox(w, Rect(20, 80, 40, 20))
		.value_(6)
		.scroll_step_(1)
		.clipLo_(1) // in effect, this is the number of pitch boxes.
		.clipHi_(6) // less than one and higher than six would crash.
		.background_(Color.blue(0.0,0.1))
		.action_({ arg mp;
			pPatNum = mp.value;
		});

pPatTransNB = NumberBox(w, Rect(60, 80, 40, 20))
		.value_(0)
		.scroll_step_(1)
		.clipLo_(-12) // in effect, this is the number of pitch boxes.
		.clipHi_(12) // less than one and higher than six would crash.
		.background_(Color.blue(0.0,0.1))
		.action_({ arg v;
			pPatTrans = (v.value).round;
			pPatNum.do({ |a| pPatArray[a] = pPatArray[a] + pPatTrans; pPatNB[a].value = pPatArray[a];  });
		});




/*resetBut = Button(w, Rect(20,120,100,20))
		.font_(Font("Helvetica", 12))
		.states_([["Reset"]])
		.action_({

	"resetting".postln;
			pPatArray[0] = 24;
			pPatArray[1] = 31;
			pPatArray[2] = 36;
			pPatArray[3] = 43;
			pPatArray[4] = 48;
			pPatArray[5] = 55;

			pPatNB[0].value = 24;
			pPatNB[1].value = 31;
			pPatNB[2].value = 36;
			pPatNB[3].value = 43;
			pPatNB[4].value = 48;
			pPatNB[5].value = 55;

		}); // end of action*/



resetBut2 = Button(w, Rect(20,120,100,20))
.states_([["Reset me"],["Stop"]])
.action_({ arg butt;
	butt.value.postln;
	mainButState = resetBut2.value;

	fork {
		while ( { mainButState == 1 }, // this is if the button is on!
			{
				"resetting".postln;
				pPatArray[0] = 24;
				pPatArray[1] = 31;
				pPatArray[2] = 36;
				pPatArray[3] = 43;
				pPatArray[4] = 48;
				pPatArray[5] = 55;

				pPatNB[0].value = 24;
				pPatNB[1].value = 31;
				pPatNB[2].value = 36;
				pPatNB[3].value = 43;
				pPatNB[4].value = 48;
				pPatNB[5].value = 55;

		} ) // end while
	}; // end fork
}); // end of action






///////////////////////////////
// Nice easy array from Touch!

pPatArray = Array.fill(pPatNum);
pPatNum.do({ |a| pPatArray[a] = 0 });

pPatArray[0] = 24;
pPatArray[1] = 31;
pPatArray[2] = 36;
pPatArray[3] = 43;
pPatArray[4] = 48;
pPatArray[5] = 55;



(


pPatNB = Array.fill(pPatNum, { arg i;
	NumberBox.new(w, Rect(20 + (38*i), 150, 34, 25))
		.font_(Font("Helvetica", 12))
		.value_(30).step_(1).clipLo_(0).clipHi_(127)
		.scroll_step_(1.0)
		.clipLo_(0)
		.action_({ arg v;
			pPatNB[i].value = v.value;
			pPatArray[i] = v.value;
		})
	});
);

pPatNB[0].value = 24;
pPatNB[1].value = 31;
pPatNB[2].value = 36;
pPatNB[3].value = 43;
pPatNB[4].value = 48;
pPatNB[5].value = 55;




// The static text for the description:


a = StaticText(w, Rect(20, 110, 480, 180));
a.font_(Font("Helvetica", 12));
a.string = "algo007 v151117: Includes a badly functioning transposed number box: you fix it.  Necessitates a reset button (this doesn't work - any ideas why?). The two boxes below play are allPass and noise frequency. The two boxes below those are number of values and transposition.";


// Synth to play it (from Streams...)

s = Server.local;

SynthDef( "Help-SPE1", { arg i_out=0, freq, allPassVal, noiseFreq=1;
	var out;
	out = RLPF.ar(
		LFSaw.ar( freq, mul: EnvGen.kr( Env.perc, levelScale: 0.3, doneAction: 2 )),
		LFNoise1.kr(noiseFreq, 36, 110).midicps,
		0.1
	);
	// out = [out, DelayN.ar(out, 0.04, 0.04) ];
	4.do({ out = AllpassN.ar(out, 0.05, [allPassVal, allPassVal], 4) });
	Out.ar( i_out, out );
}).send(s);

// here's the stream...
stream = Routine.new({
	loop({
			pPatNum.do({ |a| pPatArray[a].yield });
		});
});



mainBut = Button(w, Rect(20,20,100,20))
		.states_([["Play"],["Stop"]])
		.action_({ arg butt;
			butt.value.postln;
			mainButState = mainBut.value;

					fork {
						while ( { mainButState == 1 }, // this is if the button is on!
							{
									1.do({
									Synth( "Help-SPE1", [ \freq, stream.next.midicps, \allPassVal, allPassVal, \noiseFreq, noiseFreq ] );
									myTime.wait; // synonym for yield, used by .play to schedule next occurence
									})
						} ) // end while
					}; // end fork
		}); // end of action
w.front;
)
