(

// algo008 v002 131102
// Now works with SC 3.5.x
// List seems quite stable (although not entirely so)
// Also currently includes SinOsc and connects synth number with pop-up menu
// the synthMenu will generate errors until the synth window is opened.  I've commented it at the moment

// TO DO
// You can't insert a number into the list without it getting in a tizzy
// dislay editable characteristics
// correct transposition
// choice between patterns
// introduce arpeggiator?
// synth button opens new instance of window if one's already there.

var w;
var openSynthWindow, synthWindow;
var synthType = 0;
var synthMenu, synthMenuItems, synthMenuVal;
var synthMenu2, synthMenu2Items, synthMenu2Val;
var mainBut, mainButState;
var resetBut, synthBut;
var myTime = 0.1, timeBox, randTime;

// Synths
var noiseFreq=1, noiseFreqNB;
var allPassBox, allPassVal = 0.1;
var harmNum = 4, harmNumNB;

var pPatArray, pPatNum = 1;
var pPatNumNB;
var pPatTransNB, pPatTrans = 0;
var synthNB;


var stream;
var pPatStrF, pPattern;
var envStart=0.01, envStartNB;
var envDur=1.0, envDurNB;


///////////////////////////////////////////
// Window stuff
///////////////////////////////////////////

w = Window("SC Algorithm GUI Tutor 008", Rect(20, 800, 600, 200));

// synthWindow
// open synthWindow
openSynthWindow = {
	synthWindow = Window("Synths", Rect(200, 800, 600, 200));
	// if(synthWindow.isClosed == true, { synthWindow = SCWindow("Synths", Rect(200, 800, 600, 200)); });
	synthWindow.front;

	// synthMenu
	(



		synthMenu = PopUpMenu.new(synthWindow,Rect(20, 20, 90, 16));
		synthMenu.font = (Font("Helvetica", 9));
		synthMenuItems = [ "Sawstream", "PMOsc", "Blip", "DynKlang", "SinOsc", "Formant" ];
		synthMenu.items = (synthMenuItems);
		synthMenu.value_(0);
		synthMenu.action = {
			synthMenuVal = synthMenu.value;
			synthNB.value = synthMenuVal;
		};
	);

	synthMenuVal = 0;


};


// synthMenu2
(



synthMenu2 = PopUpMenu.new(w,Rect(130,150,100,20));
synthMenu2.font = (Font("Helvetica", 9));
synthMenu2Items = [ "Sawstream", "PMOsc", "Blip", "DynKlang", "SinOsc", "Formant" ];
synthMenu2.items = (synthMenu2Items);
synthMenu2.value_(0);
synthMenu2.action = {
	synthMenu2Val = synthMenu2.value;
	synthNB.value = synthMenu2Val;
	synthType = synthMenu2Val;
};
);

synthMenu2Val = 0;







/////////////////////////
// Time /////////////////


a = StaticText(w, Rect(130, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "Time";



timeBox = NumberBox(w, Rect(160, 20, 60, 20));
timeBox.clipLo = 0.02;
timeBox.clipHi = 32.0;
timeBox.scroll_step = 0.01;
timeBox.value = 0.11;
timeBox.action = ({ arg tb;
	myTime = tb.value;
});




// All Pass /////////////////


a = StaticText(w, Rect(20, 50, 60, 20));
a.font_(Font("Helvetica", 12));
a.string = "All Pass";



allPassBox = NumberBox(w, Rect(80, 50, 40, 20));
allPassBox.clipLo = 0.01;
allPassBox.clipHi = 32.0;
allPassBox.scroll_step = 0.01;
allPassBox.value = 0.01;
allPassBox.action = ({ arg tb;
	allPassVal = tb.value;
});




// Noise /////////////////


a = StaticText(w, Rect(140, 50, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "Noise";



noiseFreqNB = NumberBox(w, Rect(180, 50, 40, 20))
.value_(1)
.scroll_step_(1)
.clipLo_(0)
.clipHi_(200)
.background_(Color.blue(0.0,0.1))
.action_({ arg v;
	noiseFreq = v.value;
});





// Transposition /////////////////
a = StaticText(w, Rect(230, 50, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "Trans";



pPatTransNB = NumberBox(w, Rect(280, 50, 40, 20))
.value_(0)
.scroll_step_(1)
.clipLo_(-127)
.clipHi_(127)
.background_(Color.blue(0.0,0.1))
.action_({ arg v;
	pPatTrans = (v.value).round;
	pPatNum.do({ |a| pPatArray[a] = ((pPatArray[a] + pPatTrans) % 127); });
	pPatArray.postln;
});




// Synth /////////////////
a = StaticText(w, Rect(330, 50, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "Synth";

synthNB = NumberBox(w, Rect(380, 50, 40, 20))
.value_(0)
.scroll_step_(1)
.clipLo_(0)
.clipHi_(4)
.background_(Color.blue(0.0,0.1))
.action_({ arg v;
	// v returns the object itself, not the value!
	// the synthMenu will generate errors until the new window is opened.
	// synthMenu.valueAction_(synthNB.value);
	synthMenu2.valueAction_(synthNB.value);
	synthNB.value.postln;
	synthType = synthNB.value;
});





// harmNum /////////////////
a = StaticText(w, Rect(430, 50, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "Harm";

harmNumNB = NumberBox(w, Rect(480, 50, 40, 20))
.value_(4)
.scroll_step_(1)
.clipLo_(1) // in effect, this is the number of pitch boxes.
.clipHi_(127) // less than one and higher than six would crash.
.background_(Color.blue(0.0,0.1))
.action_({ arg v;
	harmNum = v.value;
});





// Envelope initial attack /////////////////
a = StaticText(w, Rect(20, 80, 60, 20));
a.font_(Font("Helvetica", 12));
a.string = "Env Start";



envStartNB = NumberBox(w, Rect(90, 80, 40, 20))
.value_(0.01)
.scroll_step_(0.01)
.clipLo_(0.0)
.clipHi_(10.0)
.background_(Color.blue(0.0,0.1))
.action_({ arg v;
	envStart = v.value;
});






// Envelope Duration /////////////////


a = StaticText(w, Rect(140, 80, 60, 20));
a.font_(Font("Helvetica", 12));
a.string = "Env Dur";



envDurNB = NumberBox(w, Rect(210, 80, 40, 20))
.value_(1.24)
.scroll_step_(0.01)
.clipLo_(0.0)
.clipHi_(10.0)
.background_(Color.blue(0.0,0.1))
.action_({ arg v;
	envDur = v.value;
});







///////////////////////////////////////////
// The Pattern Editor
///////////////////////////////////////////

a = StaticText(w, Rect(240, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "Pitch";


(
pPatStrF = {|str|

	str = str.replace("   ", " ");
	str = str.replace("  ", " ");
	str = str.replace(" ", ", ");

	str = format("[%]", str).interpret;
};

(

pPattern = TextView.new(w, Rect(280, 20, 300, 20))

.font_(Font("Helvetica", 12))
.string_("60 67 69 71 64 ")
.keyDownAction = {|view,char,modifiers,unicode,keycode,array|

	if ((unicode==32), {
		pPattern.string = pPattern.string.replace("b", "");
		// see String > Regexp
		// "[a-z] ".matchRegexp("c "); [[:alpha:]]
		// ":-(:-(:-(".tr($(, $)); //turn the frowns upside down
		pPatArray = pPatStrF.value(pPattern.string);



		pPatNum = pPatArray.size;
		pPatArray.postln;
	});

	// 48-57 = 0-9

}; // keydown
);
);


///////////////////////////////////////////
// reset button
///////////////////////////////////////////

resetBut = Button(w, Rect(20,120,100,20))
.font_(Font("Helvetica", 9))


.states_([["Reset"]])
.action_({
	pPatNum = 1;



	pPatArray = Array.fill(pPatNum);
	pPatNum.do({ |a| pPatArray[a] = 60 });
	pPatArray[0] = 60;
	pPattern.string = "60 ";


}); // end of action



// Nice easy array from Touch!



pPatNum = 5;
pPatArray = Array.fill(pPatNum);
pPatArray[0] = 60;
pPatArray[1] = 67;
pPatArray[2] = 69;
pPatArray[3] = 71;
pPatArray[4] = 64;


// synthWindow
synthBut = Button(w, Rect(20,150,100,20))
.font_(Font("Helvetica", 9))


.states_([["Synths"]])
.action_({
	// open a window!
	openSynthWindow.value();
}); // end of action







///////////////////////////////////////////
// sawStream
///////////////////////////////////////////

SynthDef( "sawStream", { arg i_out=0, freq, noiseFreq=1, envStart=0.01, envDur=5.0, allPassVal;
	var out;
	out = RLPF.ar(
		LFSaw.ar( freq, mul: EnvGen.kr( Env.perc(envStart, envDur, 0.25, -4), levelScale: 0.3, doneAction: 2 )),
		LFNoise1.kr(noiseFreq, 36, 80).midicps,
		0.1
	);
	4.do({ out = AllpassN.ar(out, 0.05, [allPassVal, allPassVal], 4) });
	Out.ar( i_out, out );
}).send(s);

///////////////////////////////////////////
// pmOsc
///////////////////////////////////////////

// PMOsc.ar(carfreq, modfreq, index, modphase, mul, add)
SynthDef( "pmOsc", { arg i_out=0, freq, noiseFreq=1, envStart=0.01, envDur=5.0, allPassVal;
	var out, e;
	// *linen(attackTime, sustainTime, releaseTime, level, curve)
	e = Env.linen(envStart, envDur, 0.1, 0.2);
	out = LinPan2.ar(EnvGen.kr(e, doneAction: 2 ) * PMOsc.ar(freq.rand,800.0.rand, Line.kr(0.0, 12.0.rand,9),0,0.1), 1.0.rand2);
	Out.ar( i_out, out );
}).send(s);

///////////////////////////////////////////
// Blip
///////////////////////////////////////////

SynthDef( "blip", { arg i_out=0, freq, noiseFreq=1, envStart=0.01, envDur=5.0, allPassVal, harmNum;
	var out;
	out = Blip.ar(freq, harmNum, mul: EnvGen.kr( Env.perc(envStart, envDur, 0.25, -4), levelScale: 0.3, doneAction: 2 ));
	4.do({ out = AllpassN.ar(out, 0.05, [allPassVal, allPassVal], 4) });
	Out.ar( i_out, out );
}).send(s);

///////////////////////////////////////////
// dynKlang
///////////////////////////////////////////

SynthDef( "dynKlang", { arg i_out=0, freq=20, noiseFreq=1, envStart=0.01, envDur=5.0, allPassVal, harmNum;
	var out;
	var mod = SinOsc.kr(Rand(0.1, 0.9), 0, Rand(5, 20));
	out = Pan2.ar(DynKlang.ar(`[ Array.rand(20, 40*10, 80*200), 1, mod ]), 1.0.rand)
	* EnvGen.kr(Env.perc(envStart, envDur, 0.25, -4), 1, 0.02, doneAction: 2);
	Out.ar( i_out, out );
}).send(s);


///////////////////////////////////////////
// sinOsc
///////////////////////////////////////////

SynthDef( "sinOsc", { arg i_out=0, freq=20, noiseFreq=1, envStart=0.01, envDur=5.0, allPassVal, harmNum;
	var out;
	out = SinOsc.ar( freq, 0, mul: EnvGen.kr( Env.perc(envStart, envDur, 0.25, -4), levelScale: 0.15, doneAction: 2 ));
	Out.ar( i_out, out );
}).send(s);



// here's the stream...

stream = Routine.new({
	loop({
		// pitch array:
		// go around the pitch array.  Don't pass the value if it's nil...
		(pPatArray.size).do({ |a| if( pPatArray[a] != nil, { pPatArray[a].yield }); });
	});
});






//PMOsc.ar




mainBut = Button(w, Rect(20,20,100,20))


.states_([["Play"],["Stop"]])
.action_({ arg butt;
	mainButState = mainBut.value;




	fork {
		while ( { mainButState == 1 },
			{
				1.do({
					case
					{ synthType == 0 } {
						// for sawStream


						defer{ Synth( "sawStream", [ \freq, stream.next.midicps, \envStart, envStart, \envDur, envDur, \allPassVal, allPassVal, \noiseFreq, noiseFreq ] ) };
					}

					{ synthType == 1 } {
						// pmOsc
						defer{ Synth( "pmOsc", [ \freq, stream.next.midicps, \envStart, envStart, \envDur, envDur, \allPassVal, allPassVal, \noiseFreq, noiseFreq ] ) };
					}

					{ synthType == 2 } {
						// Blip...
						defer{ Synth( "blip", [ \freq, stream.next.midicps, \envStart, envStart, \envDur, envDur, \allPassVal, allPassVal, \noiseFreq, noiseFreq, \harmNum, harmNum ] ) };
					}

					{ synthType == 3 } {
						// dynKlang..
						defer{ Synth( "dynKlang", [ \freq, stream.next.midicps, \envStart, envStart, \envDur, envDur, \allPassVal, allPassVal, \noiseFreq, noiseFreq, \harmNum, harmNum ] ) };
					}

					{ synthType == 4 } {
						// sinOsc..
						defer{ Synth( "sinOsc", [ \freq, stream.next.midicps, \envStart, envStart, \envDur, envDur, \allPassVal, allPassVal, \noiseFreq, noiseFreq, \harmNum, harmNum ] ) };
					}; // end case

					myTime.wait; // synonym for yield, used by .play to schedule next occurence
				}); // end do


		} ) // end while
	}; // end fork






}); // end action
w.front;










)
