

Micromontage/Plunderphonics using SC
Revision
v002
090226

Environment and Scope
Variables work according to their scope

a = 200;
a.postln;

(
var a;
a = 100;
a.postln;
)

(
var a;
a = 400;
a.postln;
)

Always check the post window for error messages when you're attempting to load a sample.  A large number of errors occur at this point.

Remember to use Terminal to find the precise path.  Don't try and work it out yourself: you'll make a mistake.  Remember that Unix needs to 'escape' blank spaces, so "Users/rich/Documents/My Documents" will be displayed as "Users/rich/Documents/My\ Documents".  This is how it should be.

Using a variable to store different paths. Notice the JitLib terminology:
~pathHome = "/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/"

Replace the path below with one based on the actual machine you're using.  Change the name to suit yourself.
~path040 = "/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/"

Of course, you can also keep sounds in relation to the SC directory, however, if the sounds are your own, they won't be transported between machines.


b = Buffer.read(s,"sounds/a11wlk01.wav");


b = Buffer.read(s,"sounds/a11wlk01.wav", bufnum: 0);



Now instead of using the absolute path, use the variable.

Absolute:

b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/SC/haiku_cage_m.aiff", bufnum: 1);

Using the path variable set up above:
b = Buffer.read(s, ~path040 ++ "haiku_cage_m.aiff", bufnum: 2);

You can also use non JitLib variables for more control within a particular environment.  In the below, the variable 'myNewPath' is only relevant within the scope of the brackets.



(
var myNewPath;
myNewPath = "/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/";
b = Buffer.read(s, myNewPath ++ "haiku_cage_m.aiff", bufnum: 2);
)



Try defining a new path (there has to be a sample there of course!).


b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/SC/haiku_cage_m.aiff", bufnum: 1);
b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/SC/sandbeat.aiff", bufnum: 2);



(


// just play it


SynthDef("help_PlayBuf", { arg out=0,bufnum=0;
	Out.ar(out,
		PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum), loop: 1)
	)
}).play);
)

b.free;




b = Buffer.read(s,"sounds/a11wlk01.wav", bufnum: 0);
b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/SC/haiku_cage_m.aiff", bufnum: 1);
b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/SC/sandbeat.aiff", bufnum: 2);





change the value of bufnum if you want to hear different buffers.



(


// just play it


SynthDef("help_PlayBuf", { arg out=0,bufnum=0;
	Out.ar(out,
		PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum), loop: 1)
	)
}).play);
)

b.free;





Alternative notation

(


SynthDef("help_PlayBuf", { arg out=0,bufnum=0;
	Out.ar(out,
		PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum), loop: 1.0)
	)
}).play(s,[\out, 0, \bufnum, b]); // alternative way of specifically requesting b.


// b is the last of the buffers we loaded, or you can use a specific buffer number instead.
// This is called 'OSC-style notation'.  You may see it elsewhere in SC help files, and if you wish investigate it to see how it compares to the other messaging style we're using.  Otherwise, feel free to ignore it!
)






Manipulate the rate



(


SynthDef("help_PlayBuf", { arg out=0,bufnum=0;
	Out.ar(out,
		PlayBuf.ar(1, bufnum, (BufRateScale.kr(bufnum) * 0.5), loop: 1.0)
	)
}).play;
)






BufRd




(
x = { arg rate=1;
	BufRd.ar(1, 2, Phasor.ar(0, BufRateScale.kr(0) * rate, 0, BufFrames.kr(0)))
}.play;
)

x.set(\rate, 0.5);
x.free;




SynthDef




(


x = SynthDef("helpBufRd", { arg out=0,bufnum=1, rate=1;
	Out.ar(out,
		BufRd.ar(1, bufnum, Phasor.ar(0, BufRateScale.kr(0) * rate, 0, BufFrames.kr(0)))
	)
}).play;
)

x.set(\rate, 1.9); // change the playback rate
x.set(\bufnum, 0); // change the buffer number (you'll need to have loaded lots of buffers here).
x.free;




Another way of doing the same thing.  Create a new synth with particular settings.



(
SynthDef("helpBufRd", { arg out=0,bufnum=1, rate=1;
	Out.ar(out,
		BufRd.ar(1, bufnum, Phasor.ar(0, BufRateScale.kr(0) * rate, 0, BufFrames.kr(0)))
	)
}).send(s);
)





s.sendMsg("/s_new", "helpBufRd", s.nextNodeID, 1, 0, "rate", 0.5, "bufnum", 0 );



























(
b = Buffer.read(s,"sounds/a11wlk01.wav");
c = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/haiku_cage_m.aiff");
d = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/sandbeat.aiff");
)






Choose one to play from (no loops and no done action)





(
SynthDef("microMontage", { arg out=0,bufnum=0;
	Out.ar(out,
		PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum))
	)
}).play(s,[\out, 0, \bufnum, [b, c, d].choose]); // see where we're choosing which buffer to play from
)

b.free;
c.free;
d.free;




Another way of doing this, being explicit with buffer numbers:





(
b = Buffer.read(s,"sounds/a11wlk01.wav", bufnum: 0);

b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/haiku_cage_m.aiff", bufnum: 1);

b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/sandbeat.aiff", bufnum: 2);
)






and choose to play from one (using no loops here)...




(


SynthDef("microMontage", { arg out=0,bufnum=0;
	Out.ar(out,
		PlayBuf.ar(1, [0, 1, 2].choose, BufRateScale.kr(bufnum))  // see where we're choosing which buffer to play from
	)
}).play;
)











Remember that 'play' is just a shorthand way of creating and playing a synthdef, so if we want control of our synth, we need to take care of them...

Below is a more complicated example, but only because it does everything at once, and because it uses an envelope on each fragment to avoid glitches.

//////////////////////////
// Go over this in detail
//////////////////////////

Arguments


PlayBuf.ar(numChannels,bufnum,rate,trigger,startPos,loop,doneAction)



(
b = Buffer.read(s,"sounds/a11wlk01.wav");
c = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/haiku_cage_m.aiff");
d = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/sandbeat.aiff");

SynthDef("plunderedFragment", { arg dur = 10, bufnum=0, myStartPos=0, rate=1;
	var out=0;
	// rate = LFNoise2.kr(XLine.kr(1, 20, 60), 2); // a more interesting use of rate
	Out.ar(0, EnvGen.kr(Env.perc(dur/2, dur/2, 1, -4), 1.0, doneAction: 2)
		* ( PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum) * rate, startPos: myStartPos, loop: 1.0 ));
	);
}).writeDefFile;



s.sendSynthDef("plunderedFragment");


)







Play a fragment.  Here, 'dur' will decide the length of the sample, 'myStartPos' the starting position (here set arbitrarily at 10000) and, of course, the bufnum...




___________________________




s.sendMsg("/s_new", "plunderedFragment", s.nextNodeID, 1, 0, "dur", 10.25, "myStartPos", 10000, "bufnum", [ b.bufnum, c.bufnum, d.bufnum ].choose );



___________________________







You could also send a message controlling 'rate' here.

___________________________

s.sendMsg("/s_new", "plunderedFragment", s.nextNodeID, 1, 0, "dur", 1.25, "myStartPos", 10000, "bufnum", [ b.bufnum, c.bufnum, d.bufnum ].choose, "rate", [ 0.2, 0.4, 0.6, 0.8, 1.2, 1.4, 1.6 ].choose );

___________________________



Finally, how about changing the starting position within each sample.  To do this, you have to know how long the sample is.  In the example above, the buffer is chosen within the message itself, but we need to know in general, so we can use a variable:




(
var myBuf;
myBuf = [ b.bufnum, c.bufnum, d.bufnum ].choose;
s.sendMsg("/s_new", "plunderedFragment", s.nextNodeID, 1, 0, "dur", 1.25, "myStartPos", 10000, "bufnum", myBuf, "rate", [ 0.2, 0.4, 0.6, 0.8, 1.2, 1.4, 1.6 ].choose );
)





So now we know that 'myBuf' is the sample SC will have chosen.  We can now use this for 'myStartPos' as well. We can use 'numFrames' to find the number:




(
var myBuf, myBufNum;
myBuf = [ b, c, d ].choose;
myBufNum = [ myBuf.bufnum, myBuf.bufnum, myBuf.bufnum ].choose;
myBuf.numFrames.postln;
s.sendMsg("/s_new", "plunderedFragment", s.nextNodeID, 1, 0, "dur", 1.25, "myStartPos", 10000, "bufnum", myBufNum, "rate", [ 0.2, 0.4, 0.6, 0.8, 1.2, 1.4, 1.6 ].choose );
)




A point about debugging, you can make your posts more explicit in this way:




(
var myBuf, myBufNum;
myBuf = [ b, c, d ].choose;
myBufNum = [ myBuf.bufnum, myBuf.bufnum, myBuf.bufnum ].choose;
("Number of frames in this sample is" + myBuf.numFrames).postln;
s.sendMsg("/s_new", "plunderedFragment", s.nextNodeID, 1, 0, "dur", 1.25, "myStartPos", 10000, "bufnum", myBufNum, "rate", [ 0.2, 0.4, 0.6, 0.8, 1.2, 1.4, 1.6 ].choose );
)






In the below, the start position is chosen as a random point from within the total number of samples within the sound file.  The duration of the sample is chosen as the 'myWait' variable.  Compare 'wait' with 'dur'.
Now make a task to play lots of fragments - a task is a pausable routine.
Note the interconnection between the variable set up and used here, and how they work with the SynthDef.   Here is is again:



(
b = Buffer.read(s,"sounds/a11wlk01.wav");
c = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/haiku_cage_m.aiff");
d = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/sandbeat.aiff");

SynthDef("plunderedFragment", { arg dur = 10, bufnum=0, myStartPos=0, rate=1;
	var out=0;
	// rate = LFNoise2.kr(XLine.kr(1, 20, 60), 2); // a more interesting use of rate
	Out.ar(0, EnvGen.kr(Env.perc(dur/2, dur/2, 1, -4), 1.0, doneAction: 2)
		* ( PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum) * rate, startPos: myStartPos, loop: 1.0 ));
	);
}).writeDefFile;



s.sendSynthDef("plunderedFragment");


)








(
r = Task({ arg myBuf, myWait;

	loop {
			// set the buffer to a variable so we can refer to it later
			myBuf = [ b, c, d ].choose;
			myWait = ((rand(4.0))+0.1).postln;
			("Total number of frames: " + myBuf.numFrames).postln;
			s.sendMsg("/s_new", "plunderedFragment", s.nextNodeID, 1, 0, "dur", myWait, "bufnum", myBuf.bufnum, "myStartPos", rand(myBuf.numFrames).postln; ); // here, myStartPos, which will be sent as the startPos argument, is chosen as a random of the number of frames in the chosen sample
			(myWait * 2.0).wait; // with the wait set to 'myWait' you'll just get one sample after another.  By diminishing the wait time, you'll get overlaps, by increasing it, ever growing gaps...  So by associating this with a global variable, you could control the density of samples...
	};
})
);

r.play;


r.pause;
r.resume;
r.stop;




Here the wait time is set to y, and the wait time multiplier to z
(
r = Task({ arg myBuf, myWait;

y = 4.0;
z = 2.0;

	loop {
			// set the buffer to a variable so we can refer to it later
			myBuf = [ b, c, d ].choose;
			myWait = ((rand(y))+0.1).postln;
			("Total number of frames: " + myBuf.numFrames).postln;
			s.sendMsg("/s_new", "plunderedFragment", s.nextNodeID, 1, 0, "dur", myWait, "bufnum", myBuf.bufnum, "myStartPos", rand(myBuf.numFrames).postln; ); // here, myStartPos, which will be sent as the startPos argument, is chosen as a random of the number of frames in the chosen sample
			(myWait * z).wait; // with the wait set to 'myWait' you'll just get one sample after another.  By diminishing the wait time, you'll get overlaps, by increasing it, ever growing gaps...  So by associating this with a global variable, you could control the density of samples...
	};
})
);

r.play;


r.pause;
r.resume;
r.stop;

y = 10.0
z = 1.0















An example utilising the rhythm more directly

Basic playback to check that it all works




b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/Micromontage-emulation/MicroEmuSounds/sandbeat.aiff", bufnum: 0);





PlayBuf.ar(numChannels,bufnum,rate,trigger,startPos,loop,doneAction)



(
SynthDef("sandRhythm", { arg out=0,bufnum=0;
	Out.ar(out,
		PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum), loop: 0)
	)
});
)









(
r = Task({ arg myBuf, sampleDur;

	loop {
			// set the buffer to a variable so we can refer to it later
			myBuf = b;
			sampleDur = (myBuf.numFrames/myBuf.sampleRate);
			("Total number of frames: " + myBuf.numFrames).postln;
			("Sample rate: " + myBuf.sampleRate).postln;
			("Duration of sample: " + sampleDur).postln;
			s.sendMsg("/s_new", "sandRhythm", s.nextNodeID, 1, 0, "dur", sampleDur, "bufnum", myBuf.bufnum );
		(sampleDur*1.0).wait;
	};
})
);

r.play;
r.pause; // when you use this, why doesn't it pause/stop directly?


r.resume;
r.stop;








Another example utilising rhythm.
This example attempts to work on the basis that a single track can be divided into a fixed number of beats, so if the track 'Lose Yourself Main' by Eminem lasts exactly 100 bars or 400 beats. This is without the intro or the outro.  So, 400 beats.





b = Buffer.read(s,"/Users/rich/Documents/College/Courses/AF130003D\ SDAC/2008-9/0809\ s2\ LessonNotes/SDaCWeek15-16-Micromontage-emulation/MicroEmuSounds/sandbeat.aiff", bufnum: 0);


c = Buffer.read(s,"/Users/rich/Documents/music/devs/algorithms/Lose Yourself Main.aif", bufnum: 1);




PlayBuf.ar(numChannels,bufnum,rate,trigger,startPos,loop,doneAction)






"/Users/rich/Documents/music/devs/algorithms/"





















s.boot;

(
SynthDef("sandRhythm", { arg dur = 10, bufnum=1, myStartPos=0, rate=1;
	var out=0;
	// rate = LFNoise2.kr(XLine.kr(1, 20, 60), 2);
	Out.ar(0, EnvGen.kr(Env.linen(dur*0.2, dur*0.6, dur*0.2, 1, -2), 1.0, doneAction: 2)
		* ( PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum) * rate, startPos: myStartPos, loop: 1.0 ));
	);
}).writeDefFile;
s.sendSynthDef("sandRhythm");
)


(
SynthDef("sandRhythm", { arg dur = 10, bufnum=1, myStartPos=0, rate=1;
	var out=0;
	// rate = LFNoise2.kr(XLine.kr(1, 20, 60), 2);
	Out.ar(0, EnvGen.kr(Env.linen(dur*0.3, dur*0.4, dur*0.3, 1, -4), 1.0, doneAction: 2)
		* ( PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum) * rate, startPos: myStartPos, loop: 1.0 ));
	);
}).add;
)

(
SynthDef("sandRhythm", { arg dur = 10, bufnum=1, myStartPos=0, rate=1;
	var out=0;
	var env = Env([0.0, 0.5, 0.0, 1.0, 0.9, 0.0], [0.05, 0.1, 0.01, 1.0, 1.5], -4);
	Out.ar(0,  EnvGen.ar(env, Dust.ar(1))
		* ( PlayBuf.ar(1, bufnum, BufRateScale.kr(bufnum) * rate, startPos: myStartPos, loop: 1.0 ));
	);
}).add;
)


"/Users/rich/Documents/research/projects/selfies/tangos/audio/Carlos Gardel - Volver (Letra-Lyrics).aif"
"/Users/rich/Documents/research/projects/selfies/tangos/audio/03 La Rosita.aif"
"/Users/rich/Documents/research/projects/selfies/tangos/audio/El Choclo.aif"



//

c = Buffer.read(s,"/Users/rich/Documents/music/devs/algorithms/Lose Yourself Main_m.aiff", bufnum: 1);

c = Buffer.read(s, "/Users/rich/Documents/research/projects/selfies/tangos/audio/03 La Rosita.aif", bufnum: 1); ~beatNum = 106 // ~106 bars

c = Buffer.read(s, "/Users/rich/Documents/research/projects/selfies/tangos/audio/El Choclo.aiff", bufnum: 1);  ~beatNum = 100
// 3'19";

c = Buffer.read(s, "/Users/rich/Documents/research/projects/selfies/tangos/audio/Carlos Gardel - Volver (Letra-Lyrics).aif", bufnum: 1); ~beatNum = 82

c = Buffer.read(s, "/Users/rich/Documents/research/projects/selfies/tangos/audio/El Mareo - Bajofondo Tango Club ft Gustavo Cerati.aif", bufnum: 1); ~beatNum = 150

c = Buffer.read(s, "/Users/rich/Documents/research/projects/selfies/tangos/audio/SE DICE DE MI TITA MERELLO TANGO.aif", bufnum: 1); ~beatNum = 180


(
r = Task({

var beatDur, randBeat=0, beatDurFrames, myBuf, sampleDur, beatNum, myRate, beatPlay;

~beatNum = 106; // the number of beats in lose yourself
	~beatLap = 1; // set the wait time for overlapping.  If you want overlapping of samples, set the wait time to beatDur * < 1, greater than 1 will result in a pause between samples.  Alternatively you can set an absolute value...
	~beatLength = 1.0;
	~beatRate = 1.0;
	~beatInc = 1;
	loop {
			// set the buffer to a variable so we can refer to it later
			myBuf = c;
		if ( ~doRandBeat == true, { randBeat = rand(~beatNum) }, { randBeat = randBeat + ~beatInc } );
			sampleDur = (myBuf.numFrames/myBuf.sampleRate); // Sample duration in seconds
			("Total number of frames: " + myBuf.numFrames).postln;
			("Sample rate: " + myBuf.sampleRate).postln;
			("Duration of sample: " + sampleDur).postln;
			beatDur = sampleDur/~beatNum;
			beatPlay = beatDur * ~beatLength; // this is the length of fragment that is actually played, here as a ratio of the actually value of the beat...
			("Duration of beat: " + beatDur + " secs").postln;
			beatDurFrames = myBuf.numFrames/~beatNum;
			("Duration of beat: " + beatDurFrames + " frames").postln;
			("Beat chosen: " + randBeat).postln;

			// Now we've gathered all our data we can send a message for a new synth on the next available node:

			s.sendMsg("/s_new", "sandRhythm", s.nextNodeID, 1, 0, "dur", beatPlay, "rate", ~beatRate, "bufnum", myBuf.bufnum, "myStartPos", (beatDurFrames * randBeat).postln);

		(beatDur*~beatLap).wait;

			// beatNum = beatNum + 10;
			~beatNum.postln;
	};
})
);

r.play;
~beatLap = 0.25 // the amount of overlapping
~beatLap = 1.0

~beatNum = 144
~beatNum = 844
~beatRate = 1
~doRandBeat = false;
~doRandBeat = true;
~beatLength = 1.0 // the length of the sample played

~beatInc = 0.01
~beatLength = 1.0
~beatRate = 1.0

~beatNum = 106*64;

~durEnv=[0.0, 0.0, 1.0];
~beatLap = 1.1

r.pause;
r.resume;
r.stop;

~beatNum = 1; // the whole piece, but you can't get out of the loop!
r.stop; ~beatNum = 100; r.play;

~beatNum = 420;

t=Synth("sandSynth")
t.set(\rate, 1.2);

types of moving through the file
forwards 1
backwards 1
random




PLUNDERPHONICS (emulation)
Link:


"http://www.plunderphonics.com/"p l u n d e r p h o n i c s



"Plunderphonics, or Audio Piracy as a Compositional Prerogative"
- as presented by John Oswald to the Wired Society Electro-Acoustic Conference in Toronto in 1985.



Musical instruments produce sounds. Composers produce music. Musical instruments reproduce music. Tape recorders, radios, disc players, etc., reproduce sound. A device such as a wind-up music box produces sound and reproduces music. A phonograph in the hands of a hip hop/scratch artist who plays a record like an electronic washboard with a phonographic needle as a plectrum, produces sounds which are unique and not reproduced - the record player becomes a musical instrument. A sampler, in essence a recording, transforming instrument, is simultaneously a documenting device and a creative device, in effect reducing a distinction manifested by copyright.






