Code for connecting SuperCollider to Logic:
NB this is provisional!]
///////////////////////////////
// get the set up ready
///////////////////////////////
///////////////////////////////

1) Load Logic and create two software instrument channels, (one for piano, one for guitar for example)
2) Select the first channel; in the inspector window you should see,about half way down, a disclosure triangle next to the name of the instrument you have chosen, click it. This will reveal some variables for this channel. Set the MIDI channel (default: all) to 1.
3) Repeat this for the second channel, setting the MIDI channel to 2.
4) Now right-click on the record button (on the transport bar) and select 'recording settings'. Make sure the 'Auto demix by channel if multitrack recording' box is ticked.
5) Load Supercollider and initialize the MIDI client and setup a MIDI out, by evaluating the following lines of code.
6) Ensure that the 'R' record button in Logic is pressed on all channels or the information is only sent to the ones that do have it selected (it turns red when when selected)


// reset all midi drivers in preferences>midi>general

MIDIClient.init(0, 1);

m = MIDIOut (0, MIDIClient.destinations[0].uid);

// simple example
// NB Midi channels in SC START at 0 (zero), so the the below messages are sent to channels 1, 2 and 2, 3 or 4 respectively...
m.noteOn(0, 70, 60); // channel 1, pitch: 70, vel: 60
m.noteOn(1, 80, 40); // channel 2, pitch: 80, vel: 40
m.noteOn([1, 2, 3].choose, [60, 63, 67].choose, 60); // channel 1, 2 or 3; pitch 60, 63 or 67


// do it automatically a number of times
(
a = Routine({
20.do({
m.noteOn([1, 2, 3].choose, [60, 63, 67].choose, 60);
[0.25, 0.125].choose.wait;
});
}).play;
)


a.reset; a.play; // try it again

a.stop;

m.disconnect


// Pdef
(Pdef(\harps,(Pbind ( \type, \midi, \midiout, m,\chan, 0,\scale, [ 11, 12, 14, 16, 17, 19, 21,]-24,\octave, Prand([4,5], inf),\degree, Pseq([ 2,3,6,5,4,7]-1, inf),\dur, Pseq([12/8,2/8, 2/8], inf),\db, -3))).quant_(4);)
Pdef(\harps).play;
Pdef(\harps).stop;
(Pdef(\glock,(Pbind ( \type, \midi, \midiout, m,\chan, 2,\scale, [ 11, 12, 14, 16, 17, 19, 21,]+12,\octave, Prand([5,6,], inf),\degree, Pseq([ 2,3,6,5,4,7]-1, inf),\dur, Pseq([1/8, 2/8, 1/8, 2/8,2/8,], inf),\db, -3))).quant_(4);)
Pdef(\glock).play;
Pdef(\glock).stop;




///////////////////////////////
// more patterns
///////////////////////////////
(a = Ppar([Pbind ( \type, \midi, \midiout, m, \chan,0,\scale, [ 10, 11, 13, 15, 16, 18, 20, 22],\degree, Prand([ 1,2,3,4,5,6,7,8,], inf),\dur, Pseq([1, 1/2, 1, 1/4, 1/4, ], inf),\db, -4),Pbind ( \type, \midi, \midiout, m, \chan,1,\scale, [ 0, 1, 3, 5, 6, 8, 10, 12],\degree, Pseq([1,3,5,7,1,5,3,7, ], inf),\dur, Pseq([1/4, 1/8, ], inf),\db, -5),], inf).play)
a.play
a.stop




///////////////////////////////
// a more involved set up
///////////////////////////////

(Pdef(\harps,(Pbind ( \type, \midi, \midiout, m,\chan, 0,\scale, [ 11, 12, 14, 16, 17, 19, 21,]-24,\octave, Prand([4,5], inf),\degree, Pseq([ 2,3,6,5,4,7]-1, inf),\dur, Pseq([12/8,2/8, 2/8], inf),\db, -3))).quant_(4);)

(Pdef(\harp2,(Pbind ( \type, \midi, \midiout, m,\chan, 1,\scale, [ 11, 12, 14, 16, 17, 19, 21,],\octave, Prand([4,5,], inf),\degree, Pseq([ 2,\rest,3,\rest,6,\rest,5,\rest,4,\rest,7,\rest,]-1, inf),\dur, Pseq([3/8,1/8, 2/8, 1/8, 1/8], inf),\db, -3,\legato, 2))).quant_(4);)

(Pdef(\cello,(Pbind ( \type, \midi, \midiout, m,\chan, 2,\scale, [ 11, 12, 14, 16, 17, 19, 21,]-36,\degree, Pseq([2,3,6,5,4,7]-1, inf),\dur, Pseq([24/8,4/8, 4/8], inf),\db, -3))).quant_(4);)

(Pdef(\glock,(Pbind ( \type, \midi, \midiout, m,\chan, 2,\scale, [ 11, 12, 14, 16, 17, 19, 21,]+12,\octave, Prand([5,6,], inf),\degree, Pseq([ 2,3,6,5,4,7]-1, inf),\dur, Pseq([1/8, 2/8, 1/8, 2/8,2/8,], inf),\db, -3))).quant_(4);)

(Pdef(\glock2,(Pbind ( \type, \midi, \midiout, m,\chan, 2,\scale, [ 11, 12, 14, 16, 17, 19, 21,]+12,
\degree, Pseq([ \rest, 2,\rest,3,\rest,6,\rest,5,\rest,4,\rest,7,]-1, inf),\dur, Pseq([3/8,1/8, 2/8, 1/8, 1/8], inf),\db, -3,\legato, 2))).quant_(4);)

(Pdef(\timpani,(Pbind ( \type, \midi, \midiout, m,\chan, 3,\scale, [ 11, 12, 14, 16, 17, 19, 21,]-24,\degree, 1,\dur, 4,\db, -3))).quant_(4);)(Pdef(\kit,(Pbind ( \type, \midi, \midiout, m,\chan, 4,\midinote, 55,\dur, 8,\db, -3))).quant_(4);)(Pdef(\kit1,(Pbind ( \type, \midi, \midiout, m,\chan, 5,\midinote, Pseq([36,\rest,\rest,],inf),\dur, 1/2,\db, -3))).quant_(4);)

(Pdef(\break,(Pbind ( \type, \midi, \midiout, m,\chan, 7,\midinote, Pseq([36,\rest,37,\rest,\rest,36,37,\rest,], inf),\dur, 1/4,\db, -3))).quant_(4);)(Pdef(\percfx,(Pbind ( \type, \midi, \midiout, m,\chan, 8,\midinote, Pseq([41,47,\rest,45,\rest,51,\rest,55,], inf),\dur, 1/2,\db, -3))).quant_(4);)

Pdef(\harps).play;Pdef(\harp2).play;Pdef(\cello).play;Pdef(\glock).play;Pdef(\glock2).play;Pdef(\timpani).play;Pdef(\kit).play;Pdef(\kit1).play;Pdef(\break).play;Pdef(\percfx).play;

Pdef(\harps).stop;Pdef(\harp2).stop;Pdef(\cello).stop;Pdef(\glock).stop;Pdef(\glock2).stop;Pdef(\timpani).stop;Pdef(\kit).stop;Pdef(\kit1).stop;Pdef(\break).stop;Pdef(\percfx).stop;
